<template>
	<form @submit.prevent="go">
		<div id="start" class="wlh-start">
			<header class="wlh-start__header">
				<h2>Search for Backlinks</h2>
				<p>
					Start by typing in a page title in the box below
				</p>
			</header>
			<div class="wlh-start__main">
				<cdx-lookup
					v-model="input"
					v-model:selected="selection"
					class="wlh-start__main-lookup"
					:menu-items="menuItems"
					:clearable="true"
					:start-icon="cdxIconSearch"
					placeholder="Search for a Wiki page"
					@input="onInput"
					@update:selected="go"
				>
					<template #no-results>
						No results found.
					</template>
				</cdx-lookup>
			</div>
			<div class="wlh-start__footer">
				<cdx-button
					type="primary"
					action="progressive"
					:disabled="!selection"
					@click="go"
				>
					Submit
				</cdx-button>
			</div>
		</div>
	</form>
</template>

<script lang="ts">
import { defineComponent, computed, ref, watch } from 'vue';
import { CdxButton, CdxLookup, MenuItemData } from '@wikimedia/codex';
import { cdxIconSearch } from '@wikimedia/codex-icons';
import { router } from '../router';

type Page = {
	title: string,
	ns: number,
	pageid: number
};

type ApiData = {
	query: {
		prefixsearch: Page[]
	}
};

interface MenuItemWithNamespace extends MenuItemData {
	ns: number,
	value: string
}

export default defineComponent( {
	name: 'StartView',
	components: {
		CdxLookup,
		CdxButton
	},
	setup() {
		const input = ref( '' );
		const menuItems = ref<MenuItemWithNamespace[]>( [] );
		const selection = ref<string|null>( null );

		const selectionData = computed( () => {
			if ( selection.value ) {
				return menuItems.value.find( ( item ) => {
					return item.label === selection.value;
				} );
			} else {
				return null;
			}
		} );

		async function fetchSuggestions( query: string ): Promise<ApiData> {
			const endpoint = 'https://en.wikipedia.org/w/api.php';
			const params = '?action=query&format=json&list=prefixsearch&formatversion=2&origin=*&pslimit=10&';
			const url = `${endpoint}${params}&pssearch=${encodeURIComponent( query )}`;
			const response = await fetch( url );
			return response.json();
		}

		async function onInput( value: string ) {
			if ( !value || value === '' ) {
				return;
			}

			try {
				const response = await fetchSuggestions( value );

				if ( input.value !== value ) {
					return;
				}

				if ( !response.query.prefixsearch || response.query.prefixsearch.length === 0 ) {
					menuItems.value = [];
					return;
				}

				menuItems.value = response.query.prefixsearch.map( ( item ) => {
					return {
						label: item.title,
						value: item.title,
						ns: item.ns
					};
				} );
			} catch ( e ) {
				menuItems.value = [];
			}
		}

		function go() {
			if ( !selectionData.value ) {
				return;
			}

			const normalizedTitle = selectionData.value.value.replace( ' ', '_' );
			const ns = selectionData.value.ns || 0;

			if ( ns === 0 ) {
				router.push( {
					path: `/pages/${normalizedTitle}`
				} );
			} else {
				const unprefixedTitle = normalizedTitle.replace( /^(.+):/, '' );
				router.push( {
					path: `/pages/${unprefixedTitle}`,
					query: { ns: selectionData.value.ns }
				} );
			}

		}

		watch( selection, ( value ) => {
			if ( value ) {
				input.value = value;
			}
		} );

		return {
			selection,
			menuItems,
			input,
			onInput,
			cdxIconSearch,
			go
		};
	}
} );
</script>

<style lang="less">
.wlh-start {
	min-height: 250px;
	padding: var(--spacing-base);
	display: flex;
	flex-direction: column;
	justify-content: flex-start;

	&__language {
		float: right;
	}
	&__main {
		flex: 1 0 auto;
		&-lookup {
			margin-top: 20px;
		}
	}

	&__footer {
		display: flex;
		justify-content: flex-end;
	}
}
</style>
